DECLARE SUB SendMOTD (idx AS INTEGER)
DECLARE FUNCTION UnixTimeEnc& (dateval AS STRING, timeval AS LONG)
DECLARE SUB ClearChan (idx AS INTEGER)
DECLARE SUB QuitClient (idx AS INTEGER, rsn AS STRING)
DECLARE SUB PartChannel (idx AS INTEGER, chnm AS STRING)
DECLARE FUNCTION ClientExists% (clnm AS STRING)
DECLARE SUB SendTopic (idx AS INTEGER, chanval AS INTEGER)
DECLARE SUB SendNames (idx AS INTEGER, chanval AS INTEGER)
DECLARE SUB BroadcastChan (chanval AS INTEGER, idx AS INTEGER, sendtosrc AS INTEGER, msg AS STRING)
DECLARE FUNCTION CreateChan% (cnm AS STRING)
DECLARE FUNCTION ChanExists% (cnm AS STRING)
DECLARE FUNCTION ChanCount% ()
DECLARE SUB JoinChannel (idx AS INTEGER, chnm AS STRING)
DECLARE SUB NickChanged (idx AS INTEGER, newnick AS STRING)
DECLARE FUNCTION NickUsed% (nickchk AS STRING)
DECLARE SUB ProcData (idx AS INTEGER, ln$)
DECLARE FUNCTION ValidChan$ (chanchk AS STRING)
DECLARE FUNCTION ValidNick$ (nickchk AS STRING)
DECLARE SUB SendError (idx AS INTEGER, errval%, msg AS STRING)
DECLARE SUB RxBuffer (idx AS INTEGER)
DECLARE FUNCTION StrReplace$ (oldmsg AS STRING, find AS STRING, rpl AS STRING)
DECLARE SUB SL (idx AS INTEGER, msg AS STRING)
DECLARE SUB ClearInfo (idx AS INTEGER)
DECLARE FUNCTION FullHostMask$ (idx%)
DECLARE SUB TxBuffer (idx AS INTEGER)
DECLARE SUB AddLog (msg AS STRING)
TYPE Registers
     ax AS INTEGER
     bx AS INTEGER
     cx AS INTEGER
     dx AS INTEGER
     bp AS INTEGER
     si AS INTEGER
     di AS INTEGER
     flags AS INTEGER
     ds AS INTEGER
     es AS INTEGER
END TYPE

'Define custom data type for nTCP-related data.
TYPE nTCP
        Enabled AS INTEGER
        IntVector AS INTEGER
        ErrorCode AS INTEGER
        LocalIP AS LONG
        LocalNetmask AS LONG
        LocalGateway AS LONG
        LocalDNS AS LONG
        LocalDomain AS STRING * 256
        DomainLen AS INTEGER
        Timeserver AS LONG
        MTU AS INTEGER
        TTL AS INTEGER
        TOS AS INTEGER
        MSS AS INTEGER
        RWIN AS INTEGER
        FreeInputPkts AS INTEGER
        FreeOutputPkts AS INTEGER
        Timeout AS INTEGER
END TYPE

'Define custom error type constants and other frequently used values.
CONST errBadCall = 1
CONST errCritical = 2
CONST errNoHandles = 3
CONST errBadHandle = 4
CONST errTimeout = 5
CONST errBadSession = 6

CONST sckListening = 1
CONST sckOpen = 4
CONST sckClosed = 7

DECLARE FUNCTION Conv2IP$ (DWord AS LONG)
DECLARE FUNCTION Conv2DWord$ (inString AS STRING)
DECLARE FUNCTION HighByte% (Word AS INTEGER)
DECLARE FUNCTION LowByte% (Word AS INTEGER)

DECLARE FUNCTION tcpInit% (Vector AS INTEGER)
DECLARE FUNCTION tcpConnect% (RemoteIP AS STRING, RemotePort AS INTEGER)
DECLARE FUNCTION tcpStatus% (tcpHandle AS INTEGER)
DECLARE FUNCTION MakeReg% (h AS INTEGER, l AS INTEGER)
DECLARE FUNCTION tcpListen% (ListenPort AS INTEGER)
DECLARE SUB tcpUnload ()
DECLARE SUB tcpSetTimeout (TimeoutSeconds AS INTEGER)
DECLARE SUB RegBlank ()
DECLARE FUNCTION tcpGetData$ (tcpHandle AS INTEGER)
DECLARE SUB tcpClose (tcpHandle AS INTEGER)
DECLARE FUNCTION tcpInBuffer% (tcpHandle AS INTEGER)
DECLARE FUNCTION tcpInputQueue% (tcpHandle AS INTEGER)
DECLARE FUNCTION tcpRemoteIP$ (tcpHandle AS INTEGER)
DECLARE SUB tcpSendData (tcpHandle AS INTEGER, Data2Send AS STRING)
DECLARE SUB tcpDoIO ()
DECLARE SUB showErrorMsg ()

DECLARE SUB interruptx (intnum AS INTEGER, inreg AS Registers, outreg AS Registers)

DECLARE SUB debugShowReturn ()

DEFINT A-Z

'Dimension variables that are shared between all subroutines and functions.
DIM SHARED tcpCall AS Registers
DIM SHARED tcpReturn AS Registers
DIM SHARED tcpDriver AS nTCP
DIM SHARED isActive AS INTEGER
DIM SHARED strGetData AS STRING * 1024
DIM SHARED strSendData AS STRING * 1024

DIM SHARED StartUnix AS LONG
DIM SHARED oper(1 TO 16, 1 TO 3) AS STRING
DIM SHARED ob(1 TO 16) AS STRING
DIM SHARED ib(1 TO 16) AS STRING
DIM SHARED client(1 TO 16, 1 TO 5) AS STRING
        'sub-array 1: nickname
        'sub-array 2: username
        'sub-array 3: hostname
        'sub-array 4: realname
        'sub-array 5: usermodes
DIM SHARED clientreg(1 TO 16) AS INTEGER
DIM SHARED clientcmode(1 TO 16, 1 TO 16) AS STRING

DIM SHARED chan(1 TO 16, 1 TO 4) AS STRING
        'sub-array 1: channel name
        'sub-array 2: channel topic
        'sub-array 3: channel modes
        'sub-array 4: clients in channel

DIM SHARED wop AS INTEGER
DIM SHARED signontime(1 TO 16) AS LONG
DIM SHARED idletime(1 TO 16) AS LONG
DIM SHARED topictime(1 TO 16) AS LONG
DIM SHARED topicwriter(1 TO 16) AS STRING
DIM SHARED banlist(1 TO 16, 1 TO 16) AS STRING
DIM SHARED lastping(1 TO 16) AS LONG
DIM SHARED pingint AS LONG
DIM SHARED pingtimeout AS LONG

DIM SHARED MOTD AS STRING
DIM SHARED build$
build$ = "v1.0 alpha [build 83008]"
DIM SHARED LocalDomain$
DIM SHARED Network$
DIM SHARED NickChar AS STRING
DIM SHARED ChanChar AS STRING
NickChar = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_|^"
ChanChar = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_"
SCREEN 0: WIDTH 80, 25: COLOR 7, 0: CLS
tcpSetTimeout 1

PRINT "IRCDLITE " + build$
PRINT "(c)2008 Mike Chambers (miker00lz@gmail.com)"
PRINT "http://www.rubbermallet.org/"
PRINT
IF VAL(RIGHT$(DATE$, 4)) > 2037 THEN
        COLOR 15, 0
        PRINT "FATAL ERROR!!!"
        COLOR 7, 0
        PRINT "Your system's date is set to a year after 2037. This is a common error on"
        PRINT "old systems such as an 8088 without a RTC card that cannot remember the date."
        PRINT "This software is programmed in QuickBASIC, which uses signed 32-bit long"
        PRINT "values. When calculating UNIX time in this IRCd, a date set too high will"
        PRINT "cause an overflow during calculation."
        PRINT
        PRINT "Please correct your system's date and time values. If the current date really"
        PRINT "is after the year 2037, ";
        COLOR 15, 0
        PRINT "WTF ARE YOU DOING ON AN 8088?!?!?! :-o"
        COLOR 7, 0
        PRINT
        PRINT "Get in your hovercar and float your ass over to the nearest computer store"
        PRINT "for a new system immediately. Thank you."
        END
END IF
AddLog "Reading configuration from IRCDLITE.INI..."
lport% = 6667
vec% = &H61
LocalDomain$ = "ircdlite.edit.your.ini.file.localhost"
Network$ = "IRCDLITE-based-server"
OPEN "IRCDLITE.INI" FOR BINARY AS #1: CLOSE #1
OPEN "IRCDLITE.INI" FOR INPUT AS #1
DO UNTIL EOF(1)
        INPUT #1, dr$
        IF dr$ <> "" THEN
                SELECT CASE LCASE$(dr$)
                        CASE "port"
                                INPUT #1, lport%
                        CASE "tcpdrv"
                                INPUT #1, vec%
                                AddLog "Will use TCPDRV on vector " + HEX$(vec%) + "h"
                        CASE "domain"
                                LINE INPUT #1, LocalDomain$
                                AddLog "Local domain: " + LocalDomain$
                        CASE "network"
                                LINE INPUT #1, Network$
                                AddLog "Network name: " + Network$
                        CASE "webport"
                                INPUT #1, webport%
                                AddLog "HTTP port:" + STR$(webport%)
                        CASE "pinginterval"
                                INPUT #1, pingint
                        CASE "pingtimeout"
                                INPUT #1, pingtimeout
                END SELECT
        END IF
LOOP
CLOSE #1
AddLog "Loading MOTD.TXT..."
OPEN "MOTD.TXT" FOR BINARY AS #1
MOTD = SPACE$(LOF(1)): GET #1, , MOTD
CLOSE #1
PRINT
AddLog "Initializing TCPDRV..."
dummy% = tcpInit(vec%)
AddLog "Resetting all sockets for listening..."
tcpClose 0
webhand% = tcpListen(webport%)
FOR rs = 1 TO 16
        tcpClose rs
        dummy% = tcpListen(lport%)
        clientreg(rs) = -1
        PRINT dummy%;
NEXT rs
AddLog "Reading OPERS.INI..."
OPEN "OPERS.INI" FOR BINARY AS #1: CLOSE #1
OPEN "OPERS.INI" FOR INPUT AS #1
wop = 0
DO UNTIL EOF(1) OR wop = 16
        INPUT #1, o$
        IF o$ <> "" THEN
                oper(wop + 1, 1) = o$
                INPUT #1, oper(wop + 1, 2)
                INPUT #1, oper(wop + 1, 3)
                wop = wop + 1
        END IF
LOOP
CLOSE #1
PRINT
AddLog "IRCDLITE is online and waiting for clients. (16 max)"
AddLog "Configured for port " + Conv2IP(tcpDriver.LocalIP) + ":" + MID$(STR$(lport%), 2)
startdate$ = DATE$
starttime$ = TIME$
StartUnix = UnixTimeEnc(DATE$, TIMER)
cshow$ = "-"
DO
        IF INKEY$ = CHR$(27) THEN EXIT DO

        stat = tcpStatus(webhand%)
        SELECT CASE stat
                CASE 0, 7, 8 'closed
                        tcpClose webhand%
                        webhand% = tcpListen(webport%)

                CASE 1 'listening

                CASE 4 'established
                        sbuff$ = "HTTP/1.1 200 OK" + CHR$(13) + CHR$(10) + "Content-type: text/html" + CHR$(13) + CHR$(10) + CHR$(13) + CHR$(10)
                        sbuff$ = sbuff$ + "<html><title>IRCDLITE " + build$ + "</title><body bgcolor=#FFFFFF text=#000000>"
                        sbuff$ = sbuff$ + "<center><table width=100% border=1 bgcolor=#F0F0F0><tr><td><center><font size=+2>IRCDLITE " + build$ + "</font><p><font size=+1>HTTP status interface</font><br><i>Generated dynamically at " + TIME$ + " on " _
 + DATE$ + "</i></td></tr></table><br><table width=512 border=2><tr><td>"
                        FOR n = 1 TO 16
                                IF client(n, 1) <> "" THEN
                                        sbuff$ = sbuff$ + "<b>Handle" + STR$(n) + ":</b> " + FullHostMask(n) + "<br>"
                                ELSE
                                        sbuff$ = sbuff$ + "<b>Handle" + STR$(n) + ":</b> Waiting for connection...<br>"
                                END IF
                        NEXT n
                        sbuff$ = sbuff$ + "</td></tr></table><br><hr><i>IRCDLITE " + build$ + " (c)2008 Mike Chambers<br><a href=" + CHR$(34) + "http://www.rubbermallet.org" + CHR$(34) + ">http://www.rubbermallet.org/</a></i>"
                        tcpSendData webhand%, sbuff$: sbuff$ = ""
                        tcpClose webhand%
        END SELECT

        FOR n = 1 TO 16
                DEF SEG = &HB800
                POKE 158, ASC(cshow$)
                DEF SEG
                SELECT CASE cshow$
                        CASE "/"
                                cshow$ = "-"
                        CASE "|"
                                cshow$ = "/"
                        CASE "\"
                                cshow$ = "|"
                        CASE "-"
                                cshow$ = "\"
                END SELECT
                stat% = tcpStatus(n)
                SELECT CASE stat%
                        CASE 0, 7, 8'closed
                                AddLog "DISCONNECT #" + MID$(STR$(n), 2) + " - " + FullHostMask(n)
                                QuitClient n, "Connection reset by peer."
                                ClearInfo n
                                dummy% = tcpListen(lport%)

                        CASE 1 'listening

                        CASE 4 'established
                                RxBuffer n
                                IF ob(n) <> "" THEN TxBuffer n
                                IF clientreg(n) = -1 THEN
                                        client(n, 3) = tcpRemoteIP(n)
                                        AddLog "NEW CONNECT #" + MID$(STR$(n), 2) + " - From " + tcpRemoteIP(n)
                                        SL n, ":" + LocalDomain$ + " NOTICE AUTH :*** Welcome to the IRC server at " + LocalDomain$ + "! You are connected on handle" + STR$(n) + " of 16."
                                        SL n, ":" + LocalDomain$ + " NOTICE AUTH :*** Looking up your hostname..."
                                        SL n, ":" + LocalDomain$ + " NOTICE AUTH :*** Couldn't resolve your hostname; using your IP address instead."
                                        SL n, ":" + LocalDomain$ + " NOTICE AUTH :*** Not checking ident; username prefixed with ~"
                                        SL n, ":" + LocalDomain$ + " NOTICE AUTH :*** Please register a nickname and username to log in."
                                        clientreg(n) = 0
                                        signontime(n) = UnixTimeEnc(DATE$, TIMER)
                                        idletime(n) = signontime(n)
                                        lastping(n) = signontime(n)
                                END IF
                                IF INSTR(1, client(n, 5), "a") THEN
                                        FOR bv = 1 TO 16
                                                IF INSTR(1, chan(bv, 4), CHR$(n)) AND INSTR(1, clientcmode(n, bv), "o") < 1 THEN
                                                        clientcmode(n, bv) = clientcmode(n, bv) + "o"
                                                        BroadcastChan bv, idx, 1, ":" + LocalDomain$ + " MODE " + chan(nv, 1) + " +o " + client(n, 1)
                                                END IF
                                        NEXT bv
                                END IF
                                GOSUB ProcBuff

                        CASE ELSE
                                'PRINT n; stat%
                END SELECT

                'IF ctm& - lastping(n) > pingtimeout THEN
                '        ib(n) = "QUIT :Ping timeout."
                'END IF

                'ctm& = UnixTimeEnc(DATE$, TIMER)
                'IF ctm& > nextping(n) THEN
                '        SL n, "PING :" + MID$(STR$(ctm&), 2)
                '        nextping(n) = ctm& + pingint
                '        lastping(n) = ctm&
                'END IF
        NEXT n
LOOP

FOR rs = 0 TO 16
        tcpClose rs
NEXT rs
END

ProcBuff:
ctm& = UnixTimeEnc(DATE$, TIMER)
DO UNTIL INSTR(1, ib(n), CHR$(13)) < 1
        x = INSTR(1, ib(n), CHR$(13))
        ln$ = LEFT$(ib(n), x - 1)
        ib(n) = MID$(ib(n), x + 1)
        
        IF ln$ <> "" THEN
                IF clientreg(n) = 0 THEN
                        x = INSTR(1, ln$, " ")
                        IF x < 1 THEN x = LEN(ln$) + 1
                        cmd$ = UCASE$(LEFT$(ln$, x - 1))
                        arg$ = MID$(ln$, x + 1)
                        IF cmd$ <> "PONG" THEN
                                idletime(n) = ctm&
                        END IF
                        SELECT CASE cmd$
                                CASE "PONG"
                                        lastping(n) = ctm&
                                CASE "PING"
                                        SL n, arg$
                                CASE "NICK"
                                        nn$ = ValidNick(arg$)
                                        IF arg$ <> "" THEN
                                                IF nn$ = "" THEN
                                                        'erroneous nick
                                                        SendError n, 432, arg$
                                                ELSE
                                                        IF NickUsed(nn$) = 1 THEN
                                                                SendError n, 433, nn$
                                                        ELSE
                                                                client(n, 1) = nn$
                                                        END IF
                                                END IF
                                        ELSE
                                                SendError n, 461, ""
                                        END IF
                                CASE "USER"
                                        IF arg$ <> "" THEN
                                                xp = INSTR(1, arg$, ":")
                                                xs = INSTR(1, arg$, " ")
                                                IF xs < 1 THEN xs = LEN(arg$) - 1
                                                client(n, 2) = LTRIM$(RTRIM$(LEFT$(arg$, xs - 1)))
                                                client(n, 4) = LTRIM$(RTRIM$(MID$(arg$, xp + 1)))
                                        ELSE
                                                SendError n, 461, ""
                                        END IF
                                CASE ELSE
                                        SendError n, 451, cmd$
                        END SELECT
                ELSE
                        ProcData n, ln$
                END IF
        END IF

'        IF ctm& - lastping(n) > pingint THEN
'                SL n, "PING :" + MID$(STR$(ctm&), 2)
'        END IF
'        IF ctm& - lastping(n) > pingtimeout THEN
'                ib(n) = "QUIT :Ping timeout." + CHR$(13)
'        END IF

        IF client(n, 1) <> "" AND client(n, 2) <> "" AND clientreg(n) = 0 THEN
                clientreg(n) = 1
                SL n, ":" + LocalDomain$ + " 001 " + client(n, 1) + " :Welcome to the IRC server at " + LocalDomain$ + " " + FullHostMask(n)
                SL n, ":" + LocalDomain$ + " 002 " + client(n, 1) + " :Your host is " + LocalDomain$ + ", running IRCDLITE " + build$ + " (Operating system: MS-DOS compatible)"
                SL n, ":" + LocalDomain$ + " 003 " + client(n, 1) + " :This server has been online since " + startdate$ + " at " + starttime$
                SL n, ":" + LocalDomain$ + " 004 " + client(n, 1) + " " + Network$ + " IRCDLITE"
                SL n, ":" + LocalDomain$ + " 005 " + client(n, 1) + " MAXCHANNEL=16 NICKLEN=32 TOPICLEN=450 :are supported by this server"
                SL n, ":" + LocalDomain$ + " 005 " + client(n, 1) + " CHANTYPES=# PREFIX(ov)@+ CHANMODES=mnt NETWORK=" + Network$ + " CASEMAPPING=ascii :are supported by this server"

                SendMOTD n

                AddLog "LOGGED IN #" + MID$(STR$(n), 2) + " - " + FullHostMask(n)
        END IF
LOOP
RETURN

SUB AddLog (msg AS STRING)
PRINT "[" + DATE$ + " " + TIME$ + "] " + msg$
END SUB

SUB BroadcastChan (chanval AS INTEGER, idx AS INTEGER, sendtosrc AS INTEGER, msg AS STRING)
FOR bc = 1 TO LEN(chan(chanval, 4))
        curcli = ASC(MID$(chan(chanval, 4), bc))
        IF curcli = idx AND sendtosrc = 0 THEN  ELSE SL curcli, msg
NEXT bc
'PRINT msg
END SUB

FUNCTION ChanCount%
tcc% = 0
FOR ccc = 1 TO 16
        IF chan(ccc, 1) <> "" THEN tcc% = tcc% + 1
NEXT ccc
ChanCount% = tcc%
END FUNCTION

FUNCTION ChanExists% (cnm AS STRING)
ChanExists% = 0
FOR cec = 1 TO 16
        IF LCASE$(chan(cec, 1)) = LCASE$(cnm) THEN ChanExists% = cec: EXIT FUNCTION
NEXT cec
END FUNCTION

SUB ClearChan (idx AS INTEGER)
FOR ci = 1 TO 4
        chan(idx, ci) = ""
NEXT ci
FOR bv = 1 TO 16
        banlist(idx, bv) = ""
NEXT bv
END SUB

SUB ClearInfo (idx AS INTEGER)
FOR ci = 1 TO 5
        client(idx, ci) = ""
NEXT ci
FOR ci = 1 TO 16
        clientcmode(idx, ci) = ""
NEXT ci
clientreg(idx) = -1
ob(idx) = ""
ib(idx) = ""
lastping(idx) = 0
END SUB

FUNCTION ClientExists% (clnm AS STRING)
ClientExists% = 0
FOR cec = 1 TO 16
        IF LCASE$(client(cec, 1)) = LCASE$(clnm) THEN ClientExists% = cec: EXIT FUNCTION
NEXT cec
END FUNCTION

DEFSNG A-Z
FUNCTION Conv2DWord$ (inString AS STRING)
'The inString variable should be an IPv4 address in the standard
'format of x.x.x.x

DIM tempArray(3) AS STRING * 1
DIM tempVal AS INTEGER

tempVal = INSTR(1, inString, ".")
IF tempVal THEN
        tempArray(0) = CHR$(VAL(LEFT$(inString, tempVal)))
        inString = MID$(inString, tempVal + 1)
ELSE
        EXIT FUNCTION
END IF

tempVal = INSTR(1, inString, ".")
IF tempVal THEN
        tempArray(1) = CHR$(VAL(LEFT$(inString, tempVal)))
        inString = MID$(inString, tempVal + 1)
ELSE
        EXIT FUNCTION
END IF

tempVal = INSTR(1, inString, ".")
IF tempVal THEN
        tempArray(2) = CHR$(VAL(LEFT$(inString, tempVal)))
        inString = MID$(inString, tempVal + 1)
ELSE
        EXIT FUNCTION
END IF

tempArray(3) = CHR$(VAL(inString))
Conv2DWord$ = tempArray(0) + tempArray(1) + tempArray(2) + tempArray(3)
END FUNCTION

FUNCTION Conv2IP$ (DWord AS LONG)
DIM tempStr AS STRING * 4

tempStr = MKL$(DWord)
Conv2IP$ = MID$(STR$(ASC(LEFT$(tempStr, 1))), 2) + "." + MID$(STR$(ASC(MID$(tempStr, 2, 1))), 2) + "." + MID$(STR$(ASC(MID$(tempStr, 3, 1))), 2) + "." + MID$(STR$(ASC(RIGHT$(tempStr, 1))), 2)
END FUNCTION

DEFINT A-Z
FUNCTION CreateChan% (cnm AS STRING)
FOR ccc = 1 TO 16
        IF chan(ccc, 1) = "" THEN
                chan(ccc, 1) = cnm
                chan(ccc, 3) = "n"
                CreateChan% = ccc
                EXIT FUNCTION
        END IF
NEXT ccc
END FUNCTION

DEFSNG A-Z
SUB debugShowReturn
PRINT "   ax:" + STR$(tcpReturn.ax) + " (" + HEX$(tcpReturn.ax) + "h)"
PRINT "   bx:" + STR$(tcpReturn.bx) + " (" + HEX$(tcpReturn.bx) + "h)"
PRINT "   cx:" + STR$(tcpReturn.cx) + " (" + HEX$(tcpReturn.cx) + "h)"
PRINT "   dx:" + STR$(tcpReturn.dx) + " (" + HEX$(tcpReturn.dx) + "h)"
PRINT "   bp:" + STR$(tcpReturn.bp) + " (" + HEX$(tcpReturn.bp) + "h)"
PRINT "   si:" + STR$(tcpReturn.si) + " (" + HEX$(tcpReturn.si) + "h)"
PRINT "   di:" + STR$(tcpReturn.di) + " (" + HEX$(tcpReturn.di) + "h)"
PRINT "flags:" + STR$(tcpReturn.flags) + " (" + HEX$(tcpReturn.flags) + "h)"
PRINT "   ds:" + STR$(tcpReturn.ds) + " (" + HEX$(tcpReturn.ds) + "h)"
PRINT "   es:" + STR$(tcpReturn.es) + " (" + HEX$(tcpReturn.es) + "h)"
END SUB

DEFINT A-Z
FUNCTION FullHostMask$ (idx)
FullHostMask$ = client(idx, 1) + "!" + client(idx, 2) + "@" + client(idx, 3)
END FUNCTION

DEFSNG A-Z
FUNCTION HighByte% (Word AS INTEGER)
HighByte% = ASC(RIGHT$(MKI$(Word), 1))
END FUNCTION

DEFINT A-Z
SUB JoinChannel (idx AS INTEGER, chnm AS STRING)
nc$ = ValidChan(chnm)
IF nc$ = "" THEN
        SendError idx, 401, chnm
        EXIT SUB
END IF
IF ChanCount = 16 THEN
        SendError idx, 405, chnm
        EXIT SUB
END IF
cexists = ChanExists(nc$)
IF cexists = 0 THEN cexists = CreateChan(chnm): freshchan = 1 ELSE freshchan = 0
IF INSTR(1, chan(cexists, 4), CHR$(idx)) THEN EXIT SUB
IF INSTR(1, client(idx, 5), "a") < 1 AND INSTR(1, client(idx, 5), "o") < 1 THEN
        FOR banval = 1 TO 16
                xb = INSTR(1, banlist(cexists, banval), "@")
                IF xb > 0 THEN
                        bant$ = MID$(banlist(cexists, banval), xb + 1)
                        IF bant$ = client(idx, 3) THEN
                                SendError idx, 474, chan(cexists, 1)
                                EXIT SUB
                        END IF
                END IF
        NEXT banval
END IF

chan(cexists, 4) = chan(cexists, 4) + CHR$(idx)

BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " JOIN " + nc$
SendNames idx, cexists
SendTopic idx, cexists
IF freshchan = 1 THEN
        clientcmode(idx, cexists) = "o"
        BroadcastChan cexists, idx, 1, ":" + LocalDomain$ + " MODE " + chan(cexists, 1) + " +o " + client(idx, 1)
ELSE
        clientcmode(idx, cexists) = ""
END IF
END SUB

DEFSNG A-Z
FUNCTION LowByte% (Word AS INTEGER)
LowByte% = ASC(LEFT$(MKI$(Word), 1))
END FUNCTION

FUNCTION MakeReg% (h AS INTEGER, l AS INTEGER)
MakeReg% = CVI(CHR$(l) + CHR$(h))
END FUNCTION

DEFINT A-Z
SUB NickChanged (idx AS INTEGER, newnick AS STRING)
SL idx, ":" + FullHostMask(idx) + " NICK " + newnick
sentto$ = CHR$(idx)
FOR ncc = 1 TO 16
        IF INSTR(1, chan(ncc, 4), CHR$(idx)) > 0 THEN
                FOR nsc = 1 TO LEN(chan(ncc, 4))
                        cv = ASC(MID$(chan(ncc, 4), nsc, 1))
                        IF INSTR(1, sentto$, CHR$(cv)) < 1 THEN
                                SL cv, ":" + FullHostMask(idx) + " NICK " + newnick
                                sentto$ = sentto$ + CHR$(cv)
                        END IF
                NEXT nsc
        END IF
NEXT ncc
END SUB

FUNCTION NickUsed% (nickchk AS STRING)
NickUsed% = 0
FOR cn = 1 TO 16
        IF LCASE$(client(cn, 1)) = LCASE$(nickchk) THEN NickUsed% = 1: EXIT FUNCTION
NEXT cn
END FUNCTION

SUB PartChannel (idx AS INTEGER, chnm AS STRING)
nc$ = ValidChan(chnm)
IF nc$ = "" THEN
        SendError idx, 401, chnm
        EXIT SUB
END IF
cexists = ChanExists(nc$)
IF cexists = 0 THEN EXIT SUB
IF INSTR(1, chan(cexists, 4), CHR$(idx)) < 1 THEN EXIT SUB

BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " PART " + nc$

y = INSTR(1, chan(cexists, 4), CHR$(idx))
chan(cexists, 4) = LEFT$(chan(cexists, 4), y - 1) + MID$(chan(cexists, 4), y + 1)
clientcmode(idx, cexists) = ""

IF chan(cexists, 4) = "" THEN ClearChan cexists
END SUB

SUB ProcData (idx AS INTEGER, ln$)
isoper = 0
IF INSTR(1, client(idx, 5), "a") OR INSTR(1, client(idx, 5), "o") THEN isoper = 1
x = INSTR(1, ln$, " ")
IF x < 1 THEN x = LEN(ln$) + 1
cmd$ = UCASE$(LEFT$(ln$, x - 1))
arg$ = MID$(ln$, x + 1)
SELECT CASE cmd$
        CASE "PONG"
                lastping(idx) = UnixTimeEnc(DATE$, TIMER)
        CASE "PING"
                SL idx, arg$
        CASE "OPER"
                xp = INSTR(1, arg$, " ")
                IF xp < 1 THEN
                        SendError idx, 461, cmd$
                ELSE
                        on$ = LTRIM$(RTRIM$(LEFT$(arg$, xp - 1)))
                        op$ = LTRIM$(RTRIM$(MID$(arg$, xp + 1)))
                        didit = 0
                        FOR os = 1 TO 16
                                IF LCASE$(on$) = LCASE$(oper(os, 1)) AND op$ = oper(os, 2) THEN
                                        didit = 1
                                        IF client(idx, 5) <> "" THEN SL idx, ":" + LocalDomain$ + " MODE " + client(idx, 1) + " -" + client(idx, 5)
                                        client(idx, 5) = oper(os, 3)
                                        SL idx, ":" + LocalDomain$ + " MODE " + client(idx, 1) + " +" + client(idx, 5)
                                END IF
                        NEXT os
                        IF didit = 0 THEN
                                SendError idx, 464, ""
                        END IF
                END IF
        CASE "INFO"
                ctm& = UnixTimeEnc(DATE$, TIMER) - StartUnix
                dy& = FIX(ctm& / 86400)
                hrs& = ctm& - (dy& * 86400)
                hrs& = FIX(hrs& / 3600)
                mns& = (dy& * 86400) + (hrs& * 3600)
                mns& = FIX((ctm& - mns&) / 60)
                sc& = (dy& * 86400) + (hrs& * 3600) + (mns& * 60)
                sc& = ctm& - sc&
                SL idx, ":" + LocalDomain$ + " 371 " + client(idx, 1) + " :Server version IRCDLITE " + build$
                SL idx, ":" + LocalDomain$ + " 371 " + client(idx, 1) + " :This server has a current uptime of" + STR$(dy&) + " days," + STR$(hrs&) + " hours," + STR$(mns&) + " minutes, and" + STR$(sc&) + " seconds."
                SL idx, ":" + LocalDomain$ + " 374 " + client(idx, 1) + " :End of /INFO list"

        CASE "NICK"
                nn$ = ValidNick(arg$)
                IF arg$ <> "" THEN
                        IF nn$ = "" THEN
                                'erroneous nick
                                SendError idx, 432, arg$
                        ELSE
                                IF NickUsed(nn$) = 1 AND LCASE$(client(idx, 1)) <> LCASE$(nn$) THEN
                                        SendError idx, 433, nn$
                                ELSE
                                        IF nn$ <> client(idx, 1) THEN
                                                NickChanged idx, nn$
                                                client(idx, 1) = nn$
                                        END IF
                                END IF
                        END IF
                ELSE
                        SendError idx, 431, ""
                END IF

        CASE "USER"
                SendError idx, 462, ""

        CASE "JOIN", "PART"
                IF arg$ = "" THEN SendError idx, 461, cmd$
                x = INSTR(1, arg$, ":")
                IF x > 0 THEN arg$ = LEFT$(arg$, x - 1)
                arg$ = RTRIM$(arg$)
                DO UNTIL arg$ = ""
                        x = INSTR(1, arg$, ",")
                        IF x < 1 THEN x = LEN(arg$) + 1
                        chname$ = LEFT$(arg$, x - 1)
                        arg$ = MID$(arg$, x + 1)
                        x = INSTR(1, chname$, " ")
                        IF x > 0 THEN
                                chkey$ = MID$(chname$, x + 1)
                                chname$ = LEFT$(chname$, x - 1)
                        ELSE
                                chkey$ = ""
                        END IF
                        
                        IF cmd$ = "JOIN" THEN
                                JoinChannel idx, chname$
                        ELSE
                                cexists = ChanExists(chname$)
                                IF cexists > 0 AND INSTR(1, chan(cexists, 4), CHR$(idx)) THEN PartChannel idx, chname$
                        END IF
                LOOP

        CASE "PRIVMSG", "NOTICE"
                x = INSTR(1, arg$, " ")
                IF x < 1 THEN
                        SendError idx, 461, cmd$
                ELSE
                        dest$ = LTRIM$(RTRIM$(LEFT$(arg$, x - 1)))
                        arg$ = LTRIM$(MID$(arg$, x + 1))
                        x = INSTR(1, arg$, ":")
                        IF x > 0 THEN arg$ = LEFT$(arg$, x - 1) + MID$(arg$, x + 1)
                        IF LEFT$(dest$, 1) = "#" THEN
                                cexists = ChanExists(dest$)
                                IF cexists < 1 THEN
                                        SendError idx, 401, dest$
                                ELSE
                                        allowmsg = 1
                                        IF INSTR(1, chan(cexists, 3), "n") > 0 AND INSTR(1, chan(cexists, 4), CHR$(idx)) < 1 THEN
                                                allowmsg = 0
                                                SendError idx, 404, dest$
                                        END IF
                                        IF INSTR(1, chan(cexists, 3), "m") > 0 THEN
                                                IF INSTR(1, clientcmode(idx, cexists), "v") < 1 AND INSTR(1, clientcmode(idx, cexists), "o") < 1 THEN
                                                        allowmsg = 0
                                                        SendError idx, 404, dest$
                                                END IF
                                        END IF
                                        IF allowmsg = 1 THEN
                                                BroadcastChan cexists, idx, 0, ":" + FullHostMask(idx) + " " + cmd$ + " " + chan(cexists, 1) + " :" + arg$
                                        END IF
                                END IF
                        ELSE
                                cexists = ClientExists(dest$)
                                IF cexists < 1 THEN
                                        SendError idx, 401, dest$
                                ELSE
                                        SL cexists, ":" + FullHostMask(idx) + " " + cmd$ + " " + client(cexists, 1) + " :" + arg$
                                END IF
                        END IF
                END IF

        CASE "TOPIC"
                x = INSTR(1, arg$, " ")
                IF x < 1 THEN
                        cexists = ChanExists(arg$)
                        IF cexists > 0 THEN
                                SendTopic idx, cexists
                        ELSE
                                SendError idx, 403, arg$
                        END IF
                ELSE
                        dest$ = LTRIM$(RTRIM$(LEFT$(arg$, x - 1)))
                        arg$ = LTRIM$(MID$(arg$, x + 1))
                        x = INSTR(1, arg$, ":")
                        IF x > 0 THEN arg$ = LEFT$(arg$, x - 1) + MID$(arg$, x + 1)
                        cexists = ChanExists(dest$)
                        IF cexists > 0 THEN
                                allowset = 1
                                IF INSTR(1, chan(cexists, 3), "t") > 0 AND INSTR(1, clientcmode(idx, cexists), "o") < 1 THEN
                                        allowset = 0
                                        SendError idx, 482, chan(cexists, 1)
                                END IF
                                IF allowset = 1 THEN
                                        chan(cexists, 2) = LEFT$(arg$, 450)
                                        BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " TOPIC " + chan(cexists, 1) + " :" + chan(cexists, 2)
                                        topicwriter(cexists) = client(idx, 1)
                                        topictime(cexists) = UnixTimeEnc(DATE$, TIMER)
                                END IF
                        ELSE
                                SendError idx, 403, dest$
                        END IF
                END IF

        CASE "MOTD"
                SendMOTD idx

        CASE "LIST"
                SL idx, ":" + LocalDomain$ + " 321 " + client(idx, 1) + " Channel :Users  Name"
                IF arg$ = "" THEN
                        FOR clc = 1 TO 16
                                IF chan(clc, 1) <> "" THEN
                                        SL idx, ":" + LocalDomain$ + " 322 " + client(idx, 1) + " " + chan(clc, 1) + STR$(LEN(chan(clc, 4))) + " :" + chan(clc, 2)
                                END IF
                        NEXT clc
                END IF
                SL idx, ":" + LocalDomain$ + " 323 " + client(idx, 1) + " :End of /LIST"

        CASE "KICK"
                IF arg$ = "" THEN
                        SendError idx, 461, cmd$
                ELSE
                        x = INSTR(1, arg$, " ")
                        IF x < 1 THEN
                                SendError idx, 461, cmd$
                        ELSE
                                dest$ = LTRIM$(RTRIM$(LEFT$(arg$, x - 1)))
                                xy = INSTR(1, arg$, ":")
                                IF xy > 0 THEN
                                        reason$ = MID$(arg$, xy + 1)
                                        arg$ = LEFT$(arg$, xy - 1)
                                ELSE
                                        reason$ = client(idx, 1)
                                END IF
                                arg$ = LTRIM$(RTRIM$(MID$(arg$, x + 1)))
                                cexists = ChanExists(dest$)
                                IF cexists > 0 THEN
                                        IF INSTR(1, clientcmode(idx, cexists), "o") < 1 THEN
                                                SendError idx, 482, chan(cexists, 1)
                                        ELSE
                                                clex = ClientExists(arg$)
                                                IF clex > 0 THEN
                                                        xc = INSTR(1, chan(cexists, 4), CHR$(clex))
                                                        IF xc < 1 THEN
                                                                SendError idx, 441, client(clex, 1) + " " + chan(cexists, 1)
                                                        ELSE
                                                                BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " KICK " + chan(cexists, 1) + " " + client(clex, 1) + " :" + reason$
                                                                chan(cexists, 4) = LEFT$(chan(cexists, 4), xc - 1) + MID$(chan(cexists, 4), xc + 1)
                                                                IF LEN(chan(cexists, 4)) = 0 THEN ClearChan cexists
                                                        END IF
                                                ELSE
                                                        SendError idx, 401, dest$
                                                END IF
                                        END IF
                                ELSE
                                        SendError idx, 403, dest$
                                END IF
                        END IF
                END IF

        CASE "WHOIS"
                IF arg$ = "" THEN SendError idx, 461, cmd$
                DO UNTIL arg$ = ""
                        x = INSTR(1, arg$, ",")
                        IF x < 1 THEN x = LEN(arg$) + 1
                        clname$ = LEFT$(arg$, x - 1)
                        arg$ = MID$(arg$, x + 1)
                        cexists = ClientExists(clname$)
                        IF cexists > 0 THEN
                                SL idx, ":" + LocalDomain$ + " 311 " + client(idx, 1) + " " + client(cexists, 1) + " " + client(cexists, 2) + " " + client(cexists, 3) + " * :" + client(cexists, 4)
                                SL idx, ":" + LocalDomain$ + " 312 " + client(idx, 1) + " " + client(cexists, 1) + " :" + LocalDomain$
                                SL idx, ":" + LocalDomain$ + " 317 " + client(idx, 1) + " " + client(cexists, 1) + STR$(UnixTimeEnc(DATE$, TIMER) - idletime(cexists)) + STR$(signontime(cexists)) + " :seconds idle, signon time"
                                SL idx, ":" + LocalDomain$ + " 318 " + client(idx, 1) + " " + client(cexists, 1) + " :End of /WHOIS list."
                        END IF
                LOOP

        CASE "NAMES"
                IF arg$ = "" THEN SendError idx, 461, cmd$
                DO UNTIL arg$ = ""
                        x = INSTR(1, arg$, ",")
                        IF x < 1 THEN x = LEN(arg$) + 1
                        chname$ = LEFT$(arg$, x - 1)
                        arg$ = MID$(arg$, x + 1)
                        cexists = ChanExists(chname$)
                        IF cexists > 0 THEN SendNames idx, cexists
                LOOP

        CASE "QUIT"
                QuitClient idx, arg$

        CASE "MODE"
                'PRINT cmd$ + " " + arg$
                IF arg$ = "" THEN
                        SendError idx, 461, cmd$
                        mm = 0
                ELSE
                        x = INSTR(1, arg$, " ")
                        IF x < 1 THEN mm = 1 ELSE mm = 2
                END IF
                SELECT CASE mm
                        CASE 1
                                IF LEFT$(arg$, 1) = "#" THEN
                                        cexists = ChanExists(ValidChan(arg$))
                                        IF cexists > 0 THEN
                                                SL idx, ":" + LocalDomain$ + " 324 " + client(idx, 1) + " " + chan(cexists, 1) + " +" + chan(cexists, 3)
                                        ELSE
                                                SendError idx, 401, arg$
                                        END IF
                                END IF
                        
                        CASE 2
                                arg2$ = RTRIM$(LTRIM$(MID$(arg$, x + 1)))
                                arg$ = RTRIM$(LTRIM$(LEFT$(arg$, x - 1)))
                                x = INSTR(1, arg2$, " ")
                                IF x > 0 THEN
                                        arg3$ = LTRIM$(MID$(arg2$, x + 1))
                                        arg2$ = RTRIM$(LEFT$(arg2$, x - 1))
                                ELSE
                                        arg3$ = arg2$
                                END IF

                                IF LEFT$(arg$, 1) = "#" THEN
                                        cexists = ChanExists(ValidChan(arg$))
                                        mt$ = LEFT$(arg2$, 1)
                                        arg2$ = MID$(arg2$, 2)
                                        IF cexists > 0 THEN
                                                FOR cp = 1 TO LEN(arg2$)
                                                cc$ = MID$(arg2$, cp, 1)
                                                SELECT CASE cc$
                                                        CASE "b"
                                                                'PRINT arg3$
                                                                IF arg3$ = "+b" THEN
                                                                        IF mt$ = "+" THEN
                                                                                FOR banval = 1 TO 16
                                                                                        IF banlist(cexists, banval) <> "" THEN
                                                                                                SL idx, ":" + LocalDomain$ + " 367 " + client(idx, 1) + " " + chan(cexists, 1) + " " + banlist(cexists, banval) + " " + LocalDomain$ + " 0"
                                                                                        END IF
                                                                                NEXT banval
                                                                                SL idx, ":" + LocalDomain$ + " 368 " + client(idx, 1) + " " + chan(cexists, 1) + " :End of ban list."
                                                                        ELSE
                                                                                SendError idx, 461, cmd$
                                                                        END IF
                                                                ELSE
                                                                IF INSTR(1, clientcmode(idx, cexists), "o") OR isoper = 1 THEN
                                                                        IF mt$ = "+" THEN
                                                                                FOR banct = 1 TO 16
                                                                                        IF banlist(cexists, banct) = "" THEN EXIT FOR
                                                                                NEXT banct
                                                                                IF banct > 16 THEN
                                                                                        SL idx, ":" + LocalDomain$ + " NOTICE " + client(idx, 1) + " :Unable to add ban to " + CHR$(2) + chan(cexists, 1) + CHR$(2) + ", banlist is full."
                                                                                ELSE
                                                                                        banlist(cexists, banct) = arg3$
                                                                                        BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " MODE " + chan(cexists, 1) + " " + mt$ + cc$ + " " + arg3$
                                                                                END IF
                                                                        ELSE
                                                                                FOR banct = 1 TO 16
                                                                                        IF banlist(cexists, banct) = arg3$ THEN
                                                                                                banlist(cexists, banct) = ""
                                                                                                BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " MODE " + chan(cexists, 1) + " " + mt$ + cc$ + " " + arg3$
                                                                                                EXIT FOR
                                                                                        END IF
                                                                                NEXT banct
                                                                        END IF
                                                                END IF
                                                                END IF

                                                        CASE "t", "m", "s", "n"
                                                                IF INSTR(1, clientcmode(idx, cexists), "o") THEN
                                                                        IF mt$ = "+" THEN
                                                                                IF INSTR(1, chan(cexists, 3), cc$) < 1 THEN
                                                                                        chan(cexists, 3) = chan(cexists, 3) + cc$
                                                                                        BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " MODE " + chan(cexists, 1) + " +" + cc$
                                                                                END IF
                                                                        ELSE
                                                                                xp = INSTR(1, chan(cexists, 3), cc$)
                                                                                IF xp > 0 THEN
                                                                                        chan(cexists, 3) = LEFT$(chan(cexists, 3), xp - 1) + MID$(chan(cexists, 3), xp + 1)
                                                                                        BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " MODE " + chan(cexists, 1) + " -" + cc$
                                                                                END IF
                                                                        END IF
                                                                ELSE
                                                                        SendError idx, 482, chan(cexists, 1)
                                                                END IF

                                                        CASE "o", "v"
                                                                IF arg3$ = "" THEN SendError idx, 461, cmd$
                                                                cexists = ChanExists(arg$)
                                                                IF cexists > 0 THEN
                                                                        IF INSTR(1, clientcmode(idx, cexists), "o") OR INSTR(1, client(idx, 5), "a") OR INSTR(1, client(idx, 5), "o") THEN
                                                                        DO UNTIL arg3$ = ""
                                                                                xp = INSTR(1, arg3$, " ")
                                                                                IF xp < 1 THEN xp = LEN(arg3$) + 1
                                                                                ca$ = LTRIM$(RTRIM$(LEFT$(arg3$, xp - 1)))
                                                                                arg3$ = MID$(arg3$, xp + 1)
                                                                                clex = ClientExists(ca$)
                                                                                IF clex > 0 AND INSTR(1, chan(cexists, 4), CHR$(clex)) THEN
                                                                                        xo = INSTR(1, clientcmode(clex, cexists), cc$)
                                                                                        IF xo < 1 THEN
                                                                                                IF mt$ = "+" THEN
                                                                                                        clientcmode(clex, cexists) = clientcmode(clex, cexists) + cc$
                                                                                                        BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " MODE " + chan(cexists, 1) + " " + mt$ + cc$ + " " + client(clex, 1)
                                                                                                END IF
                                                                                        ELSE
                                                                                                IF mt$ = "-" THEN
                                                                                                        clientcmode(clex, cexists) = LEFT$(clientcmode(clex, cexists), xo - 1) + MID$(clientcmode(clex, cexists), xo + 1)
                                                                                                        BroadcastChan cexists, idx, 1, ":" + FullHostMask(idx) + " MODE " + chan(cexists, 1) + " " + mt$ + cc$ + " " + client(clex, 1)
                                                                                                END IF
                                                                                        END IF
                                                                                END IF
                                                                        LOOP
                                                                        ELSE
                                                                                SendError idx, 482, arg$
                                                                        END IF
                                                                ELSE
                                                                        SendError idx, 403, arg2$
                                                                END IF

                                                        CASE "-", "+"
                                                                mt$ = cc$

                                                END SELECT
                                                NEXT cp
                                        ELSE
                                                SendError idx, 401, arg$
                                        END IF
                                END IF

                END SELECT

        CASE ELSE
                SendError idx, 421, cmd$
END SELECT
END SUB

SUB QuitClient (idx AS INTEGER, rsn AS STRING)
tcpClose idx
sentto$ = CHR$(idx)
FOR ncc = 1 TO 16
        IF INSTR(1, chan(ncc, 4), CHR$(idx)) > 0 THEN
                y = INSTR(1, chan(ncc, 4), CHR$(idx))
                chan(ncc, 4) = LEFT$(chan(ncc, 4), y - 1) + MID$(chan(ncc, 4), y + 1)

                FOR nsc = 1 TO LEN(chan(ncc, 4))
                        cv = ASC(MID$(chan(ncc, 4), nsc, 1))
                        IF INSTR(1, sentto$, CHR$(cv)) < 1 THEN
                                SL cv, ":" + FullHostMask(idx) + " QUIT :" + rsn
                                sentto$ = sentto$ + CHR$(cv)
                        END IF
                NEXT nsc
        END IF
NEXT ncc
END SUB

DEFSNG A-Z
SUB RegBlank
tcpCall.ax = 0
tcpCall.bx = 0
tcpCall.cx = 0
tcpCall.dx = 0
tcpCall.bp = 0
tcpCall.si = 0
tcpCall.di = 0
tcpCall.flags = 0
tcpCall.ds = 0
tcpCall.es = 0
END SUB

DEFINT A-Z
SUB RxBuffer (idx AS INTEGER)
IF INSTR(1, COMMAND$, "/NOFLOOD") < 1 AND LEN(ib(idx)) > 2048 THEN
        ib(idx) = "QUIT :Automatic boot from server! 2048-byte flood limit tripped. Bye-bye!" + CHR$(13)
        EXIT SUB
END IF
DO
        tmpin$ = tcpGetData(idx)
        IF tmpin$ <> "" THEN
                tmp$ = ""
                FOR rb = 1 TO LEN(tmpin$)
                        cc$ = MID$(tmpin$, rb, 1)
                        IF cc$ = CHR$(10) THEN cc$ = CHR$(13)
                        tmp$ = tmp$ + cc$
                NEXT rb
                ib(idx) = ib(idx) + StrReplace(tmp$, CHR$(13) + CHR$(13), CHR$(13))
        END IF
LOOP UNTIL tmpin$ = ""
END SUB

SUB SendError (idx AS INTEGER, errval, msg AS STRING)
SELECT CASE errval
        CASE 401
                t$ = "No such nick/channel"
        CASE 402
                t$ = "No such server"
        CASE 403
                t$ = "No such channel"
        CASE 404
                t$ = "Cannot send to channel"
        CASE 405
                t$ = "Too many channels"
        CASE 406
                t$ = "There was no such nickname"
        CASE 407
                t$ = "Duplicate recipients. No message delivered"
        CASE 409
                t$ = "No origin specified"
        CASE 411
                t$ = "No recipient given"
        CASE 412
                t$ = "No text to send"
        CASE 413
                t$ = "No toplevel domain specified"
        CASE 421
                t$ = "Unknown command"
        CASE 431
                t$ = "No nickname given"
        CASE 432
                t$ = "Erroneous nickname"
        CASE 433
                t$ = "Nickname is already in use"
        CASE 441
                t$ = "They aren't on that channel"
        CASE 464
                t$ = "Password incorrect"
        CASE 451
                t$ = "You have not registered"
        CASE 461
                t$ = "Not enough parameters"
        CASE 462
                t$ = "You may not reregister"
        CASE 474
                t$ = "Cannot join channel (+b)"
        CASE 482
                t$ = "You're not channel operator"
END SELECT
SL idx, ":" + LocalDomain$ + STR$(errval) + " " + client(idx, 1) + " :" + t$ + " (" + msg + ")"
END SUB

SUB SendMOTD (idx AS INTEGER)
IF MOTD = "" THEN
        SL idx, ":" + LocalDomain$ + " 422 " + client(idx, 1) + " :MOTD File is missing"
ELSE
        SL idx, ":" + LocalDomain$ + " 375 " + client(idx, 1) + " :- " + LocalDomain$ + " Message of the Day"
        sentlines = 0
        tmpmotd$ = MOTD
        DO UNTIL tmpmotd$ = ""
                xp = INSTR(1, tmpmotd$, CHR$(13) + CHR$(10))
                IF xp < 1 THEN xp = LEN(tmpmotd$) + 1
                SL idx, ":" + LocalDomain$ + " 372 " + client(idx, 1) + " :- " + LEFT$(tmpmotd$, xp - 1)
                tmpmotd$ = MID$(tmpmotd$, xp + 2)
                sentlines = sentlines + 1
                IF sentlines = 5 THEN
                        TxBuffer idx
                        sentlines = 0
                END IF
        LOOP
        IF ob(idx) <> "" THEN TxBuffer idx
END IF
SL idx, ":" + LocalDomain$ + " 376 " + client(idx, 1) + " :End of /MOTD command."
END SUB

SUB SendNames (idx AS INTEGER, chanval AS INTEGER)
tmpsent = 0
tmp$ = ":" + LocalDomain$ + " 353 " + client(idx, 1) + " = " + chan(chanval, 1) + " :"
FOR sn = 1 TO LEN(chan(chanval, 4))
        cun = ASC(MID$(chan(chanval, 4), sn, 1))
        prefix$ = ""
        IF INSTR(1, clientcmode(cun, chanval), "o") > 0 THEN prefix$ = "@"
        IF INSTR(1, clientcmode(cun, chanval), "v") > 0 THEN prefix$ = "+"
        tmp$ = tmp$ + prefix$ + client(cun, 1) + " "
        tmpsent = tmpsent + 1
        IF tmpsent = 10 OR sn = LEN(chan(chanval, 4)) THEN
                tmp$ = RTRIM$(tmp$)
                SL idx, tmp$
                tmp$ = ":" + LocalDomain$ + " 353 " + client(idx, 1) + " = " + chan(chanval, 1) + " :"
                tmpsent = 0
        END IF
NEXT sn
SL idx, ":" + LocalDomain$ + " 366 " + client(idx, 1) + " " + chan(chanval, 1) + " :End of /NAMES list"
END SUB

SUB SendTopic (idx AS INTEGER, chanval AS INTEGER)
IF chan(chanval, 2) <> "" THEN
        SL idx, ":" + LocalDomain$ + " 332 " + client(idx, 1) + " " + chan(chanval, 1) + " :" + chan(chanval, 2)
        SL idx, ":" + LocalDomain$ + " 333 " + chan(chanval, 1) + " " + topicwriter(chanval) + STR$(topictime(chanval))
ELSE
        SL idx, ":" + LocalDomain$ + " 331 " + client(idx, 1) + " " + chan(chanval, 1) + " :No topic is set"
END IF
END SUB

DEFSNG A-Z
SUB showErrorMsg
PRINT "ERROR CODE" + STR$(tcpDriver.ErrorCode) + "!!! ";
SELECT CASE tcpDriver.ErrorCode
        CASE errBadCall
                PRINT "err_badcall"
        CASE errCritical
                PRINT "err_critical"
        CASE errNoHandles
                PRINT "err_nohandles"
        CASE errBadHandle
                PRINT "err_badhandle"
        CASE errTimeout
                PRINT "err_timeout"
        CASE errBadSession
                PRINT "err_badsession"
END SELECT
END SUB

DEFINT A-Z
SUB SL (idx AS INTEGER, msg AS STRING)
ob(idx) = ob(idx) + msg + CHR$(13) + CHR$(10)
'IF LEN(ob(idx)) > 4096 THEN
        'output buffer too large... need to close socket.
'END IF
END SUB

FUNCTION StrReplace$ (oldmsg AS STRING, find AS STRING, rpl AS STRING)
DO
        x = INSTR(1, oldmsg, find)
        IF x > 0 THEN
                oldmsg = LEFT$(oldmsg, x - 1) + rpl + MID$(oldmsg, x + LEN(find))
        END IF
LOOP UNTIL x < 1
StrReplace$ = oldmsg
END FUNCTION

DEFSNG A-Z
SUB tcpClose (tcpHandle AS INTEGER)
tcpCall.ax = MakeReg(&H11, 0)
tcpCall.bx = tcpHandle
tcpCall.dx = 18

CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END SUB

FUNCTION tcpConnect% (RemoteIP AS STRING, RemotePort AS INTEGER)
DIM tempRemoteIP AS STRING
tempRemoteIP = Conv2DWord(RemoteIP)

tcpCall.ax = MakeReg(&H10, 0)
tcpCall.bx = 0
tcpCall.cx = RemotePort
tcpCall.dx = tcpDriver.Timeout
tcpCall.di = CVI(LEFT$(tempRemoteIP, 2))
tcpCall.si = CVI(RIGHT$(tempRemoteIP, 2))
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

dummyLocalPortNr% = tcpReturn.ax
'PRINT "Local port:"; dummyLocalPortNr%

tcpConnect% = tcpReturn.bx 'Makes this function return the TCPDRV handle number.
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

SUB tcpDoIO
'Allows TCPDRV to perform processing of data. THIS MUST BE CALLED REGULARLY
'for packets to be processed! If you don't do this, TCPDRV will eventually
'crash when it runs out of storage space for input and output queues.

'RegBlank
tcpCall.ax = MakeReg(&H2, 0)
tcpCall.dx = 0 'tcpDriver.Timeout
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END SUB

FUNCTION tcpGetData$ (tcpHandle AS INTEGER)
DIM tempBufferSize AS INTEGER

tcpCall.ax = MakeReg(&H12, 1)
tcpCall.bx = tcpHandle
tcpCall.es = VARSEG(strGetData)
tcpCall.di = VARPTR(strGetData)
tcpCall.cx = 1024
tcpCall.dx = 5
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)
tcpGetData$ = LEFT$(strGetData, tcpReturn.ax)

tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

FUNCTION tcpInBuffer% (tcpHandle AS INTEGER)
dummy1% = tcpStatus%(tcpHandle)
IF isActive > 0 THEN
        tcpInBuffer% = tcpReturn.ax
END IF
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

FUNCTION tcpInit% (Vector AS INTEGER)
'If given vector value is zero, assume the usual vector 61h.
IF Vector = 0 THEN Vector = &H61

tcpCall.ax = MakeReg(&H0, &HFF)
CALL interruptx(Vector, tcpCall, tcpReturn)

'This next line sets tcpDriver.Enabled to zero, sets the tcpInit function
'return value to zero, and exits the function immediately if the interrupt
'call did not return the expected value of zero for a functional TCPDRV
'vector at the specified segment.
IF tcpReturn.ax <> 0 THEN tcpDriver.Enabled = 0: tcpInit% = 0: EXIT FUNCTION

tcpInit% = 1
tcpDriver.Enabled = 1
tcpDriver.IntVector = Vector
DEF SEG = tcpReturn.es
offset = tcpReturn.di

'The following lines of code parse all of the network-related data
'from the pointer value returned by TCPDRV.
tcpDriver.LocalIP = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.LocalNetmask = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.LocalGateway = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.LocalDNS = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.Timeserver = CVL(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)) + CHR$(PEEK(offset + 2)) + CHR$(PEEK(offset + 3)))
offset = offset + 4

tcpDriver.MTU = CVI(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)))
offset = offset + 2

tcpDriver.TTL = PEEK(offset)
tcpDriver.TOS = PEEK(offset + 1)
offset = offset + 4 'Skip two unused bytes after TTL and TOS data.

tcpDriver.MSS = CVI(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)))
offset = offset + 2

tcpDriver.RWIN = CVI(CHR$(PEEK(offset)) + CHR$(PEEK(offset + 1)))
offset = offset + 4 'Skip two unused bytes after RWIN data.

'The following code segment gets the local domain string.
'TCPDRV allocates 256 bytes for this string, because that is the maximum
'allowed length of a domain name. If the string is shorter than 256 bytes,
'then TCPDRV fills the remainder of the string with ASCII code 255. The
'following code stops reading from the domain string as soon is it sees
'the first byte with a value of 255 for performance reasons.
DIM tempNum AS INTEGER
DIM tempCurByte AS STRING * 1
DIM tempStr AS STRING
FOR tempNum = offset TO offset + 255
        tempCurByte = CHR$(PEEK(tempNum))
        IF tempCurByte = CHR$(255) THEN
                tcpDriver.DomainLen = tempNum - offset
                tcpDriver.LocalDomain = tempStr
        ELSE
                tempStr = tempStr + tempCurByte
        END IF
NEXT tempNum

tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

FUNCTION tcpListen% (ListenPort AS INTEGER)
tcpCall.ax = MakeReg(&H10, 1)
tcpCall.bx = ListenPort
tcpCall.cx = 0
tcpCall.dx = 1
tcpCall.si = 0
tcpCall.di = 0
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

'dummyLocalPortNr% = tcpReturn.ax

tcpListen% = tcpReturn.bx
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

DEFINT A-Z
FUNCTION tcpRemoteIP$ (tcpHandle AS INTEGER)
checkstat% = tcpStatus(tcpHandle)
IF checkstat% <> sckOpen THEN tcpRemoteIP$ = "0.0.0.0": EXIT FUNCTION

DEF SEG = tcpReturn.es
stateoffset = tcpReturn.di
ipdest$ = Conv2IP(CVL(CHR$(PEEK(stateoffset + 6)) + CHR$(PEEK(stateoffset + 7)) + CHR$(PEEK(stateoffset + 8)) + CHR$(PEEK(stateoffset + 9))))

tcpRemoteIP$ = ipdest$
END FUNCTION

DEFSNG A-Z
SUB tcpSendData (tcpHandle AS INTEGER, Data2Send AS STRING)
DIM tsz AS INTEGER
DO UNTIL Data2Send = ""
        strSendData = LEFT$(Data2Send, 1024)
        tsz = LEN(Data2Send)
        IF tsz > 1024 THEN tsz = 1024
        Data2Send = MID$(Data2Send, 1025)

        tcpCall.ax = MakeReg(&H13, 4)
        tcpCall.bx = tcpHandle
        tcpCall.es = INT(VARSEG(strSendData))
        tcpCall.di = INT(VARPTR(strSendData))
        tcpCall.cx = tsz
        tcpCall.dx = 5
        CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

        tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
        tcpDoIO
LOOP
END SUB

SUB tcpSetTimeout (TimeoutSeconds AS INTEGER)
tcpDriver.Timeout = INT(TimeoutSeconds * 18.2)
END SUB

FUNCTION tcpStatus% (tcpHandle AS INTEGER)
tcpCall.ax = MakeReg(&H14, 0)
tcpCall.bx = tcpHandle
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

DEF SEG = tcpReturn.es
stateoffset = tcpReturn.di
ipsrce$ = Conv2IP(CVL(CHR$(PEEK(stateoffset)) + CHR$(PEEK(stateoffset + 1)) + CHR$(PEEK(stateoffset + 2)) + CHR$(PEEK(stateoffset + 3))))
ipdest$ = Conv2IP(CVL(CHR$(PEEK(stateoffset + 4)) + CHR$(PEEK(stateoffset + 5)) + CHR$(PEEK(stateoffset + 6)) + CHR$(PEEK(stateoffset + 7))))
ipprot% = PEEK(stateoffset + 8)
active% = PEEK(stateoffset + 9)
ifActive = active%
'PRINT "======================"
'PRINT "Debug: Status data return values for TCP handle"; tcpHandle
'PRINT
'PRINT "Error code:"; LowByte(tcpReturn.dx)
'PRINT "TCP state:"; HighByte(tcpReturn.dx)
'PRINT
'PRINT "Bytes available for reading:"; tcpReturn.ax
'PRINT "Bytes still being transmitted:"; tcpReturn.cx
'PRINT
'PRINT "Session info gathered from pointer" + STR$(tcpReturn.es) + ":" + MID$(STR$(tcpReturn.di), 2)
'PRINT "IP source: " + ipsrce$
'PRINT "IP dest: " + ipsrce$
'PRINT "IP prot:"; ipprot%
'PRINT "Active:"; active%
'PRINT "======================"
tcpStatus% = HighByte(tcpReturn.dx)
tcpDriver.ErrorCode = LowByte(tcpReturn.dx)
END FUNCTION

SUB tcpUnload
tcpCall.ax = MakeReg(&H1, 0)
CALL interruptx(tcpDriver.IntVector, tcpCall, tcpReturn)

tcpDriver.Enabled = 0
END SUB

DEFINT A-Z
SUB TxBuffer (idx AS INTEGER)
tcpSendData idx, ob(idx)
ob(idx) = ""
END SUB

DEFLNG A-Z
FUNCTION UnixTimeEnc& (dateval AS STRING, timeval AS LONG)
ON ERROR RESUME NEXT
DIM temptime AS LONG
tempdate$ = dateval
divider = INSTR(1, tempdate$, "-"): month = VAL(LEFT$(tempdate$, divider - 1))
tempdate$ = MID$(tempdate$, divider + 1)
divider = INSTR(1, tempdate$, "-"): day = VAL(LEFT$(tempdate$, divider - 1))
tempdate$ = MID$(tempdate$, divider + 1)
year = VAL(tempdate$)

temptime = 0
FOR calcval = 1970 TO year - 1
   'determine if a year is a leap year
   IF (calcval + 2) / 4 = FIX((calcval + 2) / 4) THEN
      daysinyear = 366
   ELSE
      daysinyear = 365
   END IF

   temptime = temptime + (daysinyear * 86400)
NEXT calcval

FOR calcval = 1 TO month - 1
   SELECT CASE calcval
      CASE 1 'Jan = 31 days
         temptime = temptime + (31 * 86400)

      CASE 2 'Feb = 28 days in common year, 29 days in leap year
         IF (year + 2) / 4 = FIX((year + 2) / 4) THEN 'it's a leap year
            temptime = temptime + (29 * 86400)
         ELSE 'it's a common year
            temptime = temptime + (28 * 86400)
      END IF

      CASE 3 'Mar = 31 days
         temptime = temptime + (31 * 86400)

      CASE 4 'Apr = 30 days
         temptime = temptime + (30 * 86400)

      CASE 5 'May = 31 days
         temptime = temptime + (31 * 86400)

      CASE 6 'Jun = 30 days
         temptime = temptime + (30 * 86400)

      CASE 7 'Jul = 31 days
         temptime = temptime + (31 * 86400)

      CASE 8 'Aug = 31 days
         temptime = temptime + (31 * 86400)

      CASE 9 'Sep = 30 days
         temptime = temptime + (30 * 86400)

      CASE 10 'Oct = 31 days
         temptime = temptime + (31 * 86400)

      CASE 11 'Nov = 31 days
         temptime = temptime + (31 * 86400)
   END SELECT
NEXT calcval

temptime = temptime + ((day - 1) * 86400) + timeval + (-timezone * 3600)
UnixTimeEnc& = temptime

END FUNCTION

DEFINT A-Z
FUNCTION ValidChan$ (chanchk AS STRING)
IF LEFT$(chanchk, 1) <> "#" THEN EXIT FUNCTION

tmp$ = "#"
FOR vn = 2 TO LEN(chanchk)
        cc$ = MID$(chanchk, vn, 1)
        IF INSTR(1, ChanChar, cc$) THEN tmp$ = tmp$ + cc$
NEXT vn
ValidChan$ = tmp$
END FUNCTION

FUNCTION ValidNick$ (nickchk AS STRING)
tmp$ = ""
FOR vn = 1 TO LEN(nickchk)
        cc$ = MID$(nickchk, vn, 1)
        IF INSTR(1, NickChar, cc$) THEN tmp$ = tmp$ + cc$
NEXT vn
ValidNick$ = tmp$
END FUNCTION

